#Compile                Exe "PBClient2_v9.exe"
#Dim                    All
%DEBUG                  = 1
$CLSID_FHGrid           = GUID$("{20000000-0000-0000-0000-000000000088}")
$IID_IFHGrid            = GUID$("{20000000-0000-0000-0000-000000000089}")
$IID_IGridEvents        = GUID$("{20000000-0000-0000-0000-00000000008A}")
%IDC_RETRIEVE1          = 1601
%IDC_COLOR1             = 1605
%IDC_UNLOAD_GRID1       = 1610
%IDC_RETRIEVE2          = 1615
%IDC_COLOR2             = 1620
%IDC_UNLOAD_GRID2       = 1625
%IDC_RETRIEVE3          = 1630
%IDC_COLOR3             = 1635
%IDC_UNLOAD_GRID3       = 1640
%IDC_RETRIEVE4          = 1645
%IDC_COLOR4             = 1650
%IDC_UNLOAD_GRID4       = 1655
%NUMBER_ROWS            = 15    'I've tested up to 500000 rows for all 4 grids,
%NUMBER_COLUMNS         = 12    'and that uses up most of the memory available.
%UNICODE                = 1     'If you try that, it takes a minute or two for
                                'the start up form to show.
#If %Def(%UNICODE)
    Macro ZStr          = WStringz
    Macro BStr          = WString
    %SIZEOF_CHAR        = 2
#Else
    Macro ZStr          = Asciiz
    Macro BStr          = String
    %SIZEOF_CHAR        = 1
#EndIf
#Include                "Windows.inc"
#Include                "ObjBase.inc"

Type WndEventArgs
  wParam                As Long
  lParam                As Long
  hWnd                  As Dword
  hInst                 As Dword
End Type

Declare Function FnPtr(wea As WndEventArgs) As Long

Type MessageHandler
  wMessage              As Long
  dwFnPtr               As Dword
End Type

Type GridInterfaces
  pGrid1                As Dword
  pGrid2                As Dword
  pGrid3                As Dword
  pGrid4                As Dword
  pSink1                As Dword
  pSink2                As Dword
  pSink3                As Dword
  pSink4                As Dword
End Type

Macro  CObj(pUnk, dwAddr) = Poke Dword, Varptr(pUnk), dwAddr

#If %Def(%DEBUG)
Sub Prnt(strLn As BStr)
  Local iLen, iWritten As Long
  Local hStdOutput As Dword
  Local strNew As BStr
  hStdOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  strNew=strLn + $CrLf
  iLen = Len(strNew)
  WriteConsole(hStdOutput, Byval Strptr(strNew), iLen, iWritten, Byval 0)
End Sub
#EndIf


Interface IGrid $IID_IFHGrid : Inherit IAutomation
  Method CreateGrid _
  ( _
    Byval hParent             As Long, _
    Byval strSetup            As BStr, _
    Byval x                   As Long, _
    Byval y                   As Long, _
    Byval cx                  As Long, _
    Byval cy                  As Long, _
    Byval iRows               As Long, _
    Byval iCols               As Long, _
    Byval iRowHt              As Long, _
    Byval iSelectionBackColor As Long, _
    Byval iSelectionTextColor As Long, _
    Byval strFontName         As BStr, _
    Byval iFontSize           As Long, _
    Byval iFontWeight         As Long _
  )
  Method SetRowCount(Byval iRowCount As Long, Byval blnForce As Long)
  Method GetRowCount() As Long
  Method SetData(Byval iRow As Long, Byval iCol As Long, Byval strData As WString)
  Method GetData(Byval iRow As Long, Byval iCol As Long) As WString
  Method FlushData()
  Method Refresh()
  Method GetVisibleRows() As Long
  Method GethGrid() As Long
  Method GethCell(Byval iRow As Long, Byval iCol As Long) As Long
  Method GethComboBox(Byval iCol As Long) As Long
  Method SetCellAttributes(Byval iRow As Long, Byval iCol As Long, Byval iBackColor As Long, Byval iTextColor As Long) As Long
  Method DeleteRow(Byval iRow As Long)
End Interface


Class GridEvents1  As Event
  Interface IGridEvents $IID_IGridEvents : Inherit IAutomation
    Method Grid_OnKeyPress(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyPress From CGridEvents1!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnKeyDown(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyDown From CGridEvents1!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnLButtonDown(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      #If %Def(%DEBUG)
      Prnt "Got WM_LBUTTONDOWN In Grid Cell From CGridEvents1" & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
      #EndIf
    End Method
    Method Grid_OnLButtonDblClk(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnPaste(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnRowSelection(Byval iRow As Long, Byval iAction As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnRowSelection(GridEvents)"
      #EndIf
    End Method
    Method Grid_OnDelete(Byval iRow As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnDelete()"
      #EndIf
    End Method
  End Interface
End Class


Class GridEvents2  As Event
  Interface IGridEvents $IID_IGridEvents : Inherit IAutomation
    Method Grid_OnKeyPress(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyPress From CGridEvents2!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnKeyDown(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyDown From CGridEvents2!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnLButtonDown(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      #If %Def(%DEBUG)
      Prnt "Got WM_LBUTTONDOWN In Grid Cell From CGridEvents1" & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
      #EndIf
    End Method
    Method Grid_OnLButtonDblClk(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnPaste(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnRowSelection(Byval iRow As Long, Byval iAction As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnRowSelection(GridEvents)"
      #EndIf
    End Method
    Method Grid_OnDelete(Byval iRow As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnDelete()"
      #EndIf
    End Method
  End Interface
End Class


Class GridEvents3  As Event
  Interface IGridEvents $IID_IGridEvents : Inherit IAutomation
    Method Grid_OnKeyPress(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyPress From CGridEvents3!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnKeyDown(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyDown From CGridEvents3!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnLButtonDown(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      #If %Def(%DEBUG)
      Prnt "Got WM_LBUTTONDOWN In Grid Cell From CGridEvents1" & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
      #EndIf
    End Method
    Method Grid_OnLButtonDblClk(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnPaste(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnRowSelection(Byval iRow As Long, Byval iAction As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnRowSelection(GridEvents)"
      #EndIf
    End Method
    Method Grid_OnDelete(Byval iRow As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnDelete()"
      #EndIf
    End Method
  End Interface
End Class


Class GridEvents4  As Event
  Interface IGridEvents $IID_IGridEvents : Inherit IAutomation
    Method Grid_OnKeyPress(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyPress From CGridEvents4!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnKeyDown(Byval iKeyCode As Long, Byval iKeyData As Long, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long, Byref blnCancel As Long)
      #If %Def(%DEBUG)
      Prnt "Got KeyDown From CGridEvents4!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
      #EndIf
    End Method
    Method Grid_OnLButtonDown(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      #If %Def(%DEBUG)
      Prnt "Got WM_LBUTTONDOWN In Grid Cell From CGridEvents4" & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
      #EndIf
    End Method
    Method Grid_OnLButtonDblClk(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnPaste(Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long)
      ' Insert your code here
    End Method
    Method Grid_OnRowSelection(Byval iRow As Long, Byval iAction As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnRowSelection(GridEvents)"
      #EndIf
    End Method
    Method Grid_OnDelete(Byval iRow As Long)
      #If %Def(%DEBUG)
      Prnt "  Entering Grid_OnDelete()"
      #EndIf
    End Method
  End Interface
End Class


Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long
  Local pSink1,pSink2,pSink3,pSink4 As IGridEvents
  Local pGridInterfaces As GridInterfaces Ptr
  Local pGrid1,pGrid2,pGrid3,pGrid4 As IGrid
  Local pCreateStruct As CREATESTRUCT Ptr
  Local strSetup,strCoordinate As BStr
  Local szName As ZStr*16
  Local hCtl As Dword
  Register i As Long
  Register j As Long

  #If %Def(%DEBUG)
  Call AllocConsole()
  Prnt "Entering fnWndProc_OnCreate() In Host"
  #EndIf
  pCreateStruct=wea.lParam  :  wea.hInst=@pCreateStruct.hInstance
  pGridInterfaces=GlobalAlloc(%GPTR,sizeof(GridInterfaces))
  If pGridInterfaces=0 Then
     MsgBox("Memory Allocation Failure")
     Function=-1 : Exit Function
  End If
  Call SetWindowLong(Wea.hWnd,0,pGridInterfaces)
  #If %Def(%DEBUG)
  Prnt "  pGridInterfaces  = " & Str$(pGridInterfaces)
  #EndIf

  'Grid #1
  pGrid1 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Objptr(pGrid1) = " & Str$(Objptr(pGrid1))
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid1 = " & Str$(ObjPtr(pGrid1))
  #EndIf
  pGrid1.AddRef()
  @pGridInterfaces.pGrid1=Objptr(pGrid1)
  strSetup= _
  "60:Tree #:^:edit," & _   ' grid col 1, 60 pixels wide; caption = 'Tree #'; center text; use edit control
  "60:Sp:^:edit," & _       ' grid col 2  60 pixels wide; caption = 'Sp'    ; center text; use edit control
  "60:Dbh:^:edit," & _      ' grid col 3  60 pixels wide; caption = 'Dbh'   ; center text; use edit control
  "60:Ht:^:edit," & _       ' grid col 4  60 pixels wide; caption = 'Ht'    ; center text; use edit control
  "60:Cull:^:edit," & _     ' grid col 5  60 pixels wide; caption = 'Cull'  ; center text; use edit control
  "60:Gd:^:edit," & _       ' grid col 6  60 pixels wide; caption = 'Gd'    ; center text; use edit control
  "60:Vol:^:edit," & _      ' grid col 7  60 pixels wide; caption = 'Vol'   ; center text; use edit control
  "60:Block:^:edit," & _    ' grid col 8  60 pixels wide; caption = 'Block' ; center text; use edit control
  "60:BkCtr:^:edit," & _    ' grid col 9  60 pixels wide; caption = 'BkCtr' ; center text; use edit control
  "60:RealSp:^:edit," & _   ' grid col 10 60 pixels wide; caption = 'RealSp'; center text; use edit control
  "60:Suffix:^:edit," & _   ' grid col 11 60 pixels wide; caption = 'Suffix'; center text; use edit control
  "60:Cru:^:edit"           ' grid col 12 60 pixels wide; caption = 'Cru'   ; center text; use edit control
  pGrid1.CreateGrid _
  ( _                       ' these parameters specify grid instance characteristics such as rows, cols, font, etc.
    Wea.hWnd, _             ' parent window handle
    strSetup, _             ' setup string as above
    10, _                   ' x coord
    10, _                   ' y coord
    570, _                  ' width
    141, _                  ' height
    %NUMBER_ROWS, _         ' number of rows in grid (may be many more than visible rows)
    %NUMBER_COLUMNS, _      ' number of grid columns
    20, _                   ' grid row height in pixels
    0, _                    ' row selection background color (default 0 = %RGB_ROYALBLUE, see IGrid_Create())
    0, _                    ' row selection text color (default 0 = %RGB_MAROON, see IGrid_Create())
    "Courier New", _        ' font
    10, _                   ' font size
    %FW_BOLD _              ' font weight
  )
  pSink1 = Class "GridEvents1"
  #If %Def(%DEBUG)
  Prnt "  pSink1         = " & Str$(Objptr(pSink1))
  #EndIf
  Events From pGrid1 Call pSink1
  @pGridInterfaces.pSink1=Objptr(pSink1)
  For i=1 To %NUMBER_ROWS
    For j=1 To %NUMBER_COLUMNS
      strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
      pGrid1.SetData(i,j,strCoordinate)
    Next j
  Next i
  pGrid1.Refresh()
  hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,158,150,24,Wea.hWnd,%IDC_RETRIEVE1,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Color Some Cells",%WS_CHILD Or %WS_VISIBLE,220,158,150,24,Wea.hWnd,%IDC_COLOR1,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,158,150,24,Wea.hWnd,%IDC_UNLOAD_GRID1,Wea.hInst,ByVal 0)

  'Grid #2
  pGrid2 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid2 = " & Str$(ObjPtr(pGrid2))
  #EndIf
  pGrid2.AddRef()
  @pGridInterfaces.pGrid2=Objptr(pGrid2)
  strSetup= _
  "60:Tree #:^:edit," & _   ' grid col 1, 60 pixels wide; caption = 'Tree #'; center text; use edit control
  "60:Sp:^:edit," & _       ' grid col 2  60 pixels wide; caption = 'Sp'    ; center text; use edit control
  "60:Dbh:^:edit," & _      ' grid col 3  60 pixels wide; caption = 'Dbh'   ; center text; use edit control
  "60:Ht:^:edit," & _       ' grid col 4  60 pixels wide; caption = 'Ht'    ; center text; use edit control
  "60:Cull:^:edit," & _     ' grid col 5  60 pixels wide; caption = 'Cull'  ; center text; use edit control
  "60:Gd:^:edit," & _       ' grid col 6  60 pixels wide; caption = 'Gd'    ; center text; use edit control
  "60:Vol:^:edit," & _      ' grid col 7  60 pixels wide; caption = 'Vol'   ; center text; use edit control
  "60:Block:^:edit," & _    ' grid col 8  60 pixels wide; caption = 'Block' ; center text; use edit control
  "60:BkCtr:^:edit," & _    ' grid col 9  60 pixels wide; caption = 'BkCtr' ; center text; use edit control
  "60:RealSp:^:edit," & _   ' grid col 10 60 pixels wide; caption = 'RealSp'; center text; use edit control
  "60:Suffix:^:edit," & _   ' grid col 11 60 pixels wide; caption = 'Suffix'; center text; use edit control
  "60:Cru:^:edit"           ' grid col 12 60 pixels wide; caption = 'Cru'   ; center text; use edit control
  pGrid2.CreateGrid _
  ( _                       ' these parameters specify grid instance characteristics such as rows, cols, font, etc.
    Wea.hWnd, _             ' parent window handle
    strSetup, _             ' setup string as above
    10, _                   ' x coord
    197, _                  ' y coord
    570, _                  ' width
    141, _                  ' height
    %NUMBER_ROWS, _         ' number of rows in grid (may be many more than visible rows)
    %NUMBER_COLUMNS, _      ' number of grid columns
    20, _                   ' grid row height in pixels
    0, _                    ' row selection background color (default 0 = %RGB_ROYALBLUE, see IGrid_Create())
    0, _                    ' row selection text color (default 0 = %RGB_MAROON, see IGrid_Create())
    "Arial", _              ' font
    10, _                   ' font size
    %FW_BOLD _              ' font weight
  )
  Let pSink2 = Class "GridEvents2"
  #If %Def(%DEBUG)
  Prnt "  pSink2         = " & Str$(Objptr(pSink2))
  #EndIf
  @pGridInterfaces.pSink2=Objptr(pSink2)
  Events From pGrid2 Call pSink2
  For i=1 To %NUMBER_ROWS
    For j=1 To %NUMBER_COLUMNS
      strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
      pGrid2.SetData(i,j,strCoordinate)
    Next j
  Next i
  pGrid2.Refresh()
  hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,346,150,24,Wea.hWnd,%IDC_RETRIEVE2,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Color Some Cells",%WS_CHILD Or %WS_VISIBLE,220,346,150,24,Wea.hWnd,%IDC_COLOR2,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,346,150,24,Wea.hWnd,%IDC_UNLOAD_GRID2,Wea.hInst,ByVal 0)

  'Grid #3
  Let pGrid3 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid3 = " & Str$(ObjPtr(pGrid3))
  #EndIf
  pGrid3.AddRef()
  @pGridInterfaces.pGrid3=Objptr(pGrid3)
  strSetup= _
  "60:Tree #:^:edit," & _
  "60:Sp:^:edit," & _
  "60:Dbh:^:edit," & _
  "60:Ht:^:edit," & _
  "60:Cull:^:edit," & _
  "60:Gd:^:edit," & _
  "60:Vol:^:edit," & _
  "60:Block:^:edit," & _
  "60:BkCtr:^:edit," & _
  "60:RealSp:^:edit," & _
  "60:Suffix:^:edit," & _
  "60:Cru:^:edit"
  pGrid3.CreateGrid _
  ( _
    Wea.hWnd, _
    strSetup, _
    10, _
    387, _
    570, _
    141, _
    %NUMBER_ROWS, _
    %NUMBER_COLUMNS, _
    20, _
    0, _
    0, _
    "Tahoma", _
    10, _
    %FW_BOLD _
  )
  Let pSink3 = Class "GridEvents3"
  #If %Def(%DEBUG)
  Prnt "  pSink3         = " & Str$(Objptr(pSink3))
  #EndIf
  @pGridInterfaces.pSink3=Objptr(pSink3)
  Events From pGrid3 Call pSink3
  For i=1 To %NUMBER_ROWS
    For j=1 To %NUMBER_COLUMNS
      strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
      pGrid3.SetData(i,j,strCoordinate)
    Next j
  Next i
  pGrid3.Refresh()
  hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,534,150,24,Wea.hWnd,%IDC_RETRIEVE3,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Color Some Cells",%WS_CHILD Or %WS_VISIBLE,220,534,150,24,Wea.hWnd,%IDC_COLOR3,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,534,150,24,Wea.hWnd,%IDC_UNLOAD_GRID3,Wea.hInst,ByVal 0)

  'Grid #4
  Let pGrid4 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid4 = " & Str$(ObjPtr(pGrid4))
  #EndIf
  pGrid4.AddRef()
  @pGridInterfaces.pGrid4=Objptr(pGrid4)
  strSetup= _
  "60:Tree #:^:edit," & _
  "60:Sp:^:edit," & _
  "60:Dbh:^:edit," & _
  "60:Ht:^:edit," & _
  "60:Cull:^:edit," & _
  "60:Gd:^:edit," & _
  "60:Vol:^:edit," & _
  "60:Block:^:edit," & _
  "60:BkCtr:^:edit," & _
  "60:RealSp:^:edit," & _
  "60:Suffix:^:edit," & _
  "60:Cru:^:edit"
  pGrid4.CreateGrid _
  ( _
    Wea.hWnd, _
    strSetup, _
    10, _
    577, _
    570, _
    141, _
    %NUMBER_ROWS, _
    %NUMBER_COLUMNS, _
    20, _
    0, _
    0, _
    "Times New Roman", _
    10, _
    %FW_BOLD _
  )
  Let pSink4 = Class "GridEvents4"
  #If %Def(%DEBUG)
  Prnt "  pSink4         = " & Str$(Objptr(pSink4))
  #EndIf
  @pGridInterfaces.pSink4=Objptr(pSink4)
  Events From pGrid4 Call pSink4
  For i=1 To %NUMBER_ROWS
    For j=1 To %NUMBER_COLUMNS
      strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
      pGrid4.SetData(i,j,strCoordinate)
    Next j
  Next i
  pGrid4.Refresh()
  hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,724,150,24,Wea.hWnd,%IDC_RETRIEVE4,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Color Some Cells",%WS_CHILD Or %WS_VISIBLE,220,724,150,24,Wea.hWnd,%IDC_COLOR4,Wea.hInst,ByVal 0)
  hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,724,150,24,Wea.hWnd,%IDC_UNLOAD_GRID4,Wea.hInst,ByVal 0)
  #If %Def(%DEBUG)
  Prnt "Leaving fnWndProc_OnCreate() In Host"
  #EndIf

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnCommand(Wea As WndEventArgs) As Long
  Local pGridInterfaces As GridInterfaces Ptr
  Local pSink1,pSink2,pSink3,pSink4 As IGridEvents
  Local pGrid1,pGrid2,pGrid3,pGrid4 As IGrid
  Local strData As BStr
  Register i As Long

  #If %Def(%DEBUG)
  Prnt "Entering fnWndProc_OnCommand()"
  #EndIf
  pGridInterfaces=GetWindowLong(Wea.hWnd,0)
  #If %Def(%DEBUG)
  Prnt "  pGridInterfaces         = " & Str$(pGridInterfaces)
  #EndIf
  Select Case As Long Lowrd(Wea.wParam)
    Case %IDC_RETRIEVE1
      If @pGridInterfaces.pGrid1 Then
         CObj(pGrid1,@pGridInterfaces.pGrid1)
         pGrid1.AddRef()
         pGrid1.FlushData()
         strData=pGrid1.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell 3, 2 Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_RETRIEVE2
      If @pGridInterfaces.pGrid2 Then
         CObj(pGrid2,@pGridInterfaces.pGrid2)
         pGrid2.AddRef()
         pGrid2.FlushData()
         strData=pGrid2.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell 3, 2 Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_RETRIEVE3
       If @pGridInterfaces.pGrid3 Then
         CObj(pGrid3,@pGridInterfaces.pGrid3)
         pGrid3.AddRef()
         pGrid3.FlushData()
         strData=pGrid3.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell 3, 2 Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_RETRIEVE4
      If @pGridInterfaces.pGrid4 Then
         CObj(pGrid4,@pGridInterfaces.pGrid4)
         pGrid4.AddRef()
         pGrid4.FlushData()
         strData=pGrid4.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell 3, 2 Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_COLOR1
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR1
         #EndIf
         If @pGridInterfaces.pGrid1 Then
            CObj(pGrid1,@pGridInterfaces.pGrid1)
            pGrid1.AddRef()
            pGrid1.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid1.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid1.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid1.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid1.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid1.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_COLOR2
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR2
         #EndIf
         If @pGridInterfaces.pGrid2 Then
            CObj(pGrid2,@pGridInterfaces.pGrid2)
            pGrid2.AddRef()
            pGrid2.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid2.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid2.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid2.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid2.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid2.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_COLOR3
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR3
         #EndIf
         If @pGridInterfaces.pGrid3 Then
            CObj(pGrid3,@pGridInterfaces.pGrid3)
            pGrid3.AddRef()
            pGrid3.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid3.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid3.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid3.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid3.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid3.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_COLOR4
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR4
         #EndIf
         If @pGridInterfaces.pGrid4 Then
            CObj(pGrid4,@pGridInterfaces.pGrid4)
            pGrid4.AddRef()
            pGrid4.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid4.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid4.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid4.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid4.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid4.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_UNLOAD_GRID1
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid1 = " & Str$(@pGridInterfaces.pGrid1)
      Prnt "  @pGridInterfaces.pSink1 = " & Str$(@pGridInterfaces.pSink1)
      #EndIf
      CObj(pGrid1,@pGridInterfaces.pGrid1)
      CObj(pSink1,@pGridInterfaces.pSink1)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE1),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR1),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID1),%False)
      Events End pSink1 :  Set pGrid1=Nothing : Set pSink1=Nothing
      @pGridInterfaces.pGrid1=0 : @pGridInterfaces.pSink1=0
      Call InvalidateRect(Wea.hWnd, Byval 0, %True)
    Case %IDC_UNLOAD_GRID2
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid2 = " & Str$(@pGridInterfaces.pGrid2)
      Prnt "  @pGridInterfaces.pSink2 = " & Str$(@pGridInterfaces.pSink2)
      #EndIf
      CObj(pGrid2,@pGridInterfaces.pGrid2)
      CObj(pSink2,@pGridInterfaces.pSink2)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE2),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR2),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID2),%False)
      Events End pSink2  :  Set pGrid2=Nothing  :  Set pSink2=Nothing
      @pGridInterfaces.pGrid2=0 : @pGridInterfaces.pSink2=0
      Call InvalidateRect(Wea.hWnd, Byval 0, %True)
    Case %IDC_UNLOAD_GRID3
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid3 = " & Str$(@pGridInterfaces.pGrid3)
      Prnt "  @pGridInterfaces.pSink3 = " & Str$(@pGridInterfaces.pSink3)
      #EndIf
      CObj(pGrid3,@pGridInterfaces.pGrid3)
      CObj(pSink3,@pGridInterfaces.pSink3)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE3),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR3),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID3),%False)
      Events End pSink3  :  Set pGrid3=Nothing  :  Set pSink3=Nothing
      @pGridInterfaces.pGrid3=0 : @pGridInterfaces.pSink3=0
      Call InvalidateRect(Wea.hWnd, Byval 0, %True)
    Case %IDC_UNLOAD_GRID4
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid4 = " & Str$(@pGridInterfaces.pGrid4)
      Prnt "  @pGridInterfaces.pSink4 = " & Str$(@pGridInterfaces.pSink4)
      #EndIf
      CObj(pGrid4,@pGridInterfaces.pGrid4)
      CObj(pSink4,@pGridInterfaces.pSink4)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE4),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR4),%False)
      Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID4),%False)
      Events End pSink4  :  Set pGrid4=Nothing  :  Set pSink4=Nothing
      @pGridInterfaces.pGrid4=0 : @pGridInterfaces.pSink4=0
      Call InvalidateRect(Wea.hWnd, Byval 0, %True)
  End Select
  #If %Def(%DEBUG)
  Prnt "Leaving fnWndProc_OnCommand()"
  #EndIf

  fnWndProc_OnCommand=0
End Function


Function fnWndProc_OnDestroy(Wea As WndEventArgs) As Long
  Local pGridInterfaces As GridInterfaces Pointer
  Local pSink1,pSink2,pSink3,pSink4 As IGridEvents
  Local pGrid1,pGrid2,pGrid3,pGrid4 As IGrid
  Local blnFree As Long

  #If %Def(%DEBUG)
  Prnt "Entering fnWndProc_OnDestroy() In Host"
  #EndIf
  pGridInterfaces=GetWindowLong(Wea.hWnd,0)
  #If %Def(%DEBUG)
  Prnt "  pGridInterfaces = " & Str$(pGridInterfaces)
  #EndIf

  'Grid #1
  If @pGridInterfaces.pSink1 Then
     CObj(pSink1,@pGridInterfaces.pSink1)
     If IsObject(pSink1) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pSink1 = " & Str$(@pGridInterfaces.pSink1)
        #EndIf
        Events End pSink1 : Set pSink1=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pSink1 Was Already Released!"
     #EndIf
  End If
  If @pGridInterfaces.pGrid1 Then
     CObj(pGrid1,@pGridInterfaces.pGrid1)
     If IsObject(pGrid1) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pGrid1 = " & Str$(@pGridInterfaces.pGrid1)
        #EndIf
        Set pGrid1=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pGrid1 Was Already Released!"
     #EndIf
  End If

  'Grid #2
  If @pGridInterfaces.pSink2 Then
     CObj(pSink2,@pGridInterfaces.pSink2)
     If IsObject(pSink2) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pSink2 = " & Str$(@pGridInterfaces.pSink2)
        #EndIf
        Events End pSink2 : Set pSink2=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pSink2 Was Already Released!"
     #EndIf
  End If
  If @pGridInterfaces.pGrid2 Then
     CObj(pGrid2,@pGridInterfaces.pGrid2)
     If IsObject(pGrid2) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pGrid2 = " & Str$(@pGridInterfaces.pGrid2)
        #EndIf
        Set pGrid2=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pGrid2 Was Already Released!"
     #EndIf
  End If

  'Grid #3
  If @pGridInterfaces.pSink3 Then
     CObj(pSink3,@pGridInterfaces.pSink3)
     If IsObject(pSink3) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pSink3 = " & Str$(@pGridInterfaces.pSink3)
        #EndIf
        Events End pSink3 : Set pSink3=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pSink3 Was Already Released!"
     #EndIf
  End If
  If @pGridInterfaces.pGrid3 Then
     CObj(pGrid3,@pGridInterfaces.pGrid3)
     If IsObject(pGrid3) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pGrid3 = " & Str$(@pGridInterfaces.pGrid3)
        #EndIf
        Set pGrid3=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pGrid3 Was Already Released!"
     #EndIf
  End If

  'Grid #4
  If @pGridInterfaces.pSink4 Then
     CObj(pSink4,@pGridInterfaces.pSink4)
     If IsObject(pSink4) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pSink4 = " & Str$(@pGridInterfaces.pSink4)
        #EndIf
        Events End pSink4 : Set pSink4=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pSink4 Was Already Released!"
     #EndIf
  End If
  If @pGridInterfaces.pGrid4 Then
     CObj(pGrid4,@pGridInterfaces.pGrid4)
     If IsObject(pGrid4) Then
        #If %Def(%DEBUG)
        Prnt "  @pGridInterfaces.pGrid4 = " & Str$(@pGridInterfaces.pGrid4)
        #EndIf
        Set pGrid4=Nothing
     End If
  Else
     #If %Def(%DEBUG)
     Prnt "  pGrid4 Was Already Released!"
     #EndIf
  End If

  If pGridInterfaces Then
     blnFree=GlobalFree(pGridInterfaces)
     #If %Def(%DEBUG)
     Prnt "  GlobalFree(pGridInterfaces) = " & Str$(blnFree)
     #EndIf
  Else
     #If %Def(%DEBUG)
     Prnt "  GlobalFree(pGridInterfaces) Failed Or Was Already Released!"
     #EndIf
  End If
  Call CoFreeUnusedLibraries()
  Call PostQuitMessage(0)
  #If %Def(%DEBUG)
  Prnt "Leaving fnWndProc_OnDestroy() In Host"
  #EndIf

  fnWndProc_OnDestroy=0
End Function


Sub AttachMessageHandlers()
  Dim MsgHdlr(2) As Global MessageHandler 'Associate Windows Message With Message Handlers
  MsgHdlr(0).wMessage=%WM_CREATE          : MsgHdlr(0).dwFnPtr=CodePtr(fnWndProc_OnCreate)
  MsgHdlr(1).wMessage=%WM_COMMAND         : MsgHdlr(1).dwFnPtr=CodePtr(fnWndProc_OnCommand)
  MsgHdlr(2).wMessage=%WM_DESTROY         : MsgHdlr(2).dwFnPtr=CodePtr(fnWndProc_OnDestroy)
End Sub


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 2
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnWndProc=iReturn
       Exit Function
    End If
  Next i

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hInstance As Long, ByVal hPrevIns As Long, ByVal lpCmdLn As ZStr Ptr, ByVal iShow As Long) As Long
  Local szAppName As ZStr*16
  Local wc As WndClassEx
  Local hWnd As Dword
  Local Msg As tagMsg

  szAppName="Grid Test"                           : Call AttachMessageHandlers()
  wc.lpszClassName = VarPtr(szAppName)            : wc.lpfnWndProc   = CodePtr(fnWndProc)
  wc.cbWndExtra    = 4                            : wc.cbSize        = SizeOf(wc)
  wc.hInstance     = hInstance                    : wc.hbrBackground = %COLOR_BTNFACE+1
  Call RegisterClassEx(wc)
  hWnd=CreateWindowEx(0,szAppName,szAppName,%WS_OVERLAPPEDWINDOW,300,50,600,790,0,0,hInstance,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend : MsgBox("Last Chance To Get What You Can!")

  Function=msg.wParam
End Function
