#Compile                              Exe "PBClient3_v9.exe"  'This is the same program essentially
#Dim                                  All                     'as PBClient2_v9.bas, except I built
%DEBUG                                = 1                     'the event sinks myself, as opposed to
$AppName                              = "Grid Test"           'using PowerBASIC's built in ones.
$IID_IUnknown                         = Guid$("{00000000-0000-0000-C000-000000000046}")
$IID_IClassFactory                    = Guid$("{00000001-0000-0000-C000-000000000046}")
$IID_IConnectionPoint                 = Guid$("{B196B286-BAB4-101A-B69C-00AA00341D07}")
$IID_IConnectionPointContainer        = Guid$("{B196B284-BAB4-101A-B69C-00AA00341D07}")
$CLSID_FHGrid                         = GUID$("{20000000-0000-0000-0000-000000000088}")
$IID_IFHGrid                          = GUID$("{20000000-0000-0000-0000-000000000089}")
$IID_IGridEvents                      = GUID$("{20000000-0000-0000-0000-00000000008A}")
%IDC_RETRIEVE1                        = 1601
%IDC_COLOR1                           = 1605
%IDC_UNLOAD_GRID1                     = 1610
%IDC_RETRIEVE2                        = 1615
%IDC_COLOR2                           = 1620
%IDC_UNLOAD_GRID2                     = 1625
%IDC_RETRIEVE3                        = 1630
%IDC_COLOR3                           = 1635
%IDC_UNLOAD_GRID3                     = 1640
%IDC_RETRIEVE4                        = 1645
%IDC_COLOR4                           = 1650
%IDC_UNLOAD_GRID4                     = 1655
%NUMBER_ROWS                          = 15    'I've tested up to 500000 rows for all 4 grids,
%NUMBER_COLUMNS                       = 12    'and that uses up most of the memory available.
%UNICODE                              = 1     'If you try that, it takes a minute or two for
                                              'the start up form to show.
#If %Def(%UNICODE)
    Macro ZStr                        = WStringz
    Macro BStr                        = WString
    %SIZEOF_CHAR                      = 2
#Else
    Macro ZStr                        = Asciiz
    Macro BStr                        = String
    %SIZEOF_CHAR                      = 1
#EndIf
#Include                              "Windows.inc"
#Include                              "ObjBase.inc"

Type WndEventArgs
  wParam                              As Long
  lParam                              As Long
  hWnd                                As Dword
  hInst                               As Dword
End Type

Declare Function FnPtr(wea As WndEventArgs) As Long

Type MessageHandler
  wMessage                            As Long
  dwFnPtr                             As Dword
End Type

Type GridInterfaces
  pGrid1                              As Dword
  pGrid2                              As Dword
  pGrid3                              As Dword
  pGrid4                              As Dword
  dwCookie1                           As Dword
  dwCookie2                           As Dword
  dwCookie3                           As Dword
  dwCookie4                           As Dword
End Type

Type IConnectionPointContainerVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  EnumConnectionPoints                As Dword Ptr
  FindConnectionPoint                 As Dword Ptr
End Type

Type IConnectionPointContainer1
  lpVtbl                              As IConnectionPointContainerVtbl Ptr
End Type

Type IConnectionPointVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  GetConnectionInterface              As Dword Ptr
  GetConnectionPointContainer         As Dword Ptr
  Advise                              As Dword Ptr
  Unadvise                            As Dword Ptr
  EnumConnections                     As Dword Ptr
End Type

Type IConnectionPoint1
  lpVtbl                              As IConnectionPointVtbl Ptr
End Type

Type IEventsVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  Grid_OnKeyPress                     As Dword Ptr
  Grid_OnKeyDown                      As Dword Ptr
  Grid_OnLButtonDown                  As Dword Ptr
  Grid_OnLButtonDblClk                As Dword Ptr
  Grid_OnPaste                        As Dword Ptr
  Grid_OnRowSelection                 As Dword Ptr
  Grid_OnDelete                       As Dword Ptr
End Type

Type IEvents
  lpVtbl                              As IEventsVtbl Ptr
End Type

Type CSink
  lpIEventsVtbl                       As IEventsVtbl Ptr
  hMain                               As Dword
  m_cRef                              As Long
End Type


Macro  CObj(pUnk, dwAddr) = Poke Dword, Varptr(pUnk), dwAddr

#If %Def(%DEBUG)
Sub Prnt(strLn As BStr)
  Local iLen, iWritten As Long
  Local hStdOutput As Dword
  Local strNew As BStr
  hStdOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  strNew=strLn + $CrLf
  iLen = Len(strNew)
  WriteConsole(hStdOutput, Byval Strptr(strNew), iLen, iWritten, Byval 0)
End Sub
#EndIf

Function IEvents1_QueryInterface(Byval this As IEvents Ptr, Byref iid As Guid, Byval ppv As Dword Ptr ) As Long
  #If %Def(%DEBUG)
  Prnt "  Entering IEvents1::QueryInterface() -- this = " & Str$(this)
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      #If %Def(%DEBUG)
      Prnt "  Trying To Get IUnknown"
      #EndIf
      Call IEvents1_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents1_QueryInterface()"
      #EndIf
    Case $IID_IGridEvents
      #If %Def(%DEBUG)
      Prnt "  Trying To Get $IID_IGridEvents"
      #EndIf
      Call IEvents1_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents1_QueryInterface()"
      #EndIf
    Case Else
      Function=%E_NOINTERFACE
      Exit Function
  End Select

  Function=%S_Ok
End Function


Function IEvents1_AddRef(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "      Entering IEvents1_AddRef()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Incr @pSink.m_cRef
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
  Prnt "      Leaving IEvents1_AddRef()"
  #EndIf

  IEvents1_AddRef=@pSink.m_cRef
End Function


Function IEvents1_Release(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "    Entering IGridEvents1_Release()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Decr @pSink.m_cRef
  If @pSink.m_cRef=0 Then
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = 0 And Will Now Delete CGridSink!"
     #EndIf
     Call CoTaskMemFree(@pSink.@lpIEventsVtbl)
     Call CoTaskMemFree(@this)
     #If %Def(%DEBUG)
     Prnt "      CGridSink Was Deleted!"
     Prnt "    Leaving IGridEvents1_Release()"
     #EndIf
     Function=0 : Exit Function
  Else
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
     Prnt "    Leaving IGridEvents1_Release()"
     #EndIf
     Function=@pSink.m_cRef : Exit Function
  End If
End Function


Function IEvents1_OnKeyPress(Byval this As IEvents Ptr, Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long) As Long
  Function=%S_Ok
End Function


Function IEvents1_OnKeyDown(Byval this As IEvents Ptr,Byval iKeyCode As Long,Byval iKeyData As Long,Byval iCellRow As Long,Byval iGridRow As Long,Byval iCol As Long,Byref blnCancel As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got KeyDown From Grid1!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
  #EndIf
  Function=%S_Ok
End Function


Function IEvents1_OnLButtonDown(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got WM_LBUTTONDOWN In Grid1 Cell " & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
  #EndIf
  Function=%S_Ok
End Function


Function IEvents1_OnLButtonDblClk(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents1_OnPaste(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents1_OnRowSelection(Byval this As IEvents Ptr, Byval iRow As Long, Byval iAction As Long) As Long
  Function=%S_Ok
End Function


Function IEvents1_OnDelete(Byval this As IEvents Ptr, Byval iRow As Long) As Long
  Function=%S_OK
End Function


Function CreateSink1() As Dword
  Local pIEvents_Vtbl As IEventsVtbl Ptr
  Local pSink1 As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "  Entering CreateSink1()"
  #EndIf
  pIEvents_Vtbl=CoTaskMemAlloc(SizeOf(IEventsVtbl))
  If pIEvents_Vtbl Then
     @pIEvents_Vtbl.QueryInterface       = CodePtr(IEvents1_QueryInterface)
     @pIEvents_Vtbl.AddRef               = CodePtr(IEvents1_AddRef)
     @pIEvents_Vtbl.Release              = CodePtr(IEvents1_Release)
     @pIEvents_Vtbl.Grid_OnKeyPress      = CodePtr(IEvents1_OnKeyPress)
     @pIEvents_Vtbl.Grid_OnKeyDown       = CodePtr(IEvents1_OnKeyDown)
     @pIEvents_Vtbl.Grid_OnLButtonDown   = CodePtr(IEvents1_OnLButtonDown)
     @pIEvents_Vtbl.Grid_OnLButtonDblClk = CodePtr(IEvents1_OnLButtonDblClk)
     @pIEvents_Vtbl.Grid_OnPaste         = CodePtr(IEvents1_OnPaste)
     @pIEvents_Vtbl.Grid_OnRowSelection  = CodePtr(IEvents1_OnRowSelection)
     @pIEvents_Vtbl.Grid_OnDelete        = CodePtr(IEvents1_OnDelete)
     pSink1=CoTaskMemAlloc(SizeOf(CSink))
     If pSink1 Then
        @pSink1.lpIEventsVtbl = pIEvents_Vtbl
        #If %Def(%DEBUG)
        Prnt "    @pSink1.lpIEventsVtbl         = " & Str$(@pSink1.lpIEventsVtbl)
        #EndIf
        @pSink1.m_cRef=0
        #If %Def(%DEBUG)
        Prnt "    pSink1                        = " & Str$(pSink1)
        #EndIf
        @pSink1.hMain                           =     FindWindow($AppName, $AppName)
        #If %Def(%DEBUG)
        Prnt "    @pSink1.hMain                 = " & Str$(@pSink1.hMain)
        #EndIf
        CreateSink1=pSink1
     Else
        CreateSink1=0
     End If
  Else
     CreateSink1=0
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving CreateSink1()"
  #EndIf
End Function


Function IEvents2_QueryInterface(Byval this As IEvents Ptr, Byref iid As Guid, Byval ppv As Dword Ptr ) As Long
  #If %Def(%DEBUG)
  Prnt "  Entering IEvents2::QueryInterface() -- this = " & Str$(this)
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      #If %Def(%DEBUG)
      Prnt "  Trying To Get IUnknown"
      #EndIf
      Call IEvents2_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents2_QueryInterface()"
      #EndIf
    Case $IID_IGridEvents
      #If %Def(%DEBUG)
      Prnt "  Trying To Get $IID_IGridEvents"
      #EndIf
      Call IEvents2_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents2_QueryInterface()"
      #EndIf
    Case Else
      Function=%E_NOINTERFACE : Exit Function
  End Select

  Function=%S_Ok
End Function


Function IEvents2_AddRef(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "      Entering IEvents2_AddRef()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Incr @pSink.m_cRef
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
  Prnt "      Leaving IEvents2_AddRef()"
  #EndIf

  IEvents2_AddRef=@pSink.m_cRef
End Function


Function IEvents2_Release(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "    Entering IGridEvents2_Release()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Decr @pSink.m_cRef
  If @pSink.m_cRef=0 Then
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = 0 And Will Now Delete CGridSink2!"
     #EndIf
     Call CoTaskMemFree(@pSink.@lpIEventsVtbl)
     Call CoTaskMemFree(@this)
     #If %Def(%DEBUG)
     Prnt "      CGridSink2 Was Deleted!"
     Prnt "    Leaving IGridEvents2_Release()"
     #EndIf
     Function=0 : Exit Function
  Else
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
     Prnt "    Leaving IGridEvents2_Release()"
     #EndIf
     Function=@pSink.m_cRef : Exit Function
  End If
End Function


Function IEvents2_OnKeyPress(Byval this As IEvents Ptr, Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got KeyPress From Grid2!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
  #EndIf
  Function=%S_Ok
End Function


Function IEvents2_OnKeyDown(Byval this As IEvents Ptr,Byval iKeyCode As Long,Byval iKeyData As Long,Byval iCellRow As Long,Byval iGridRow As Long,Byval iCol As Long,Byref blnCancel As Long) As Long
  Function=%S_Ok
End Function


Function IEvents2_OnLButtonDown(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got WM_LBUTTONDOWN In Grid2 Cell " & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
  #EndIf
  Function=%S_Ok
End Function


Function IEvents2_OnLButtonDblClk(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents2_OnPaste(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents2_OnRowSelection(Byval this As IEvents Ptr, Byval iRow As Long, Byval iAction As Long) As Long
  Function=%S_Ok
End Function


Function IEvents2_OnDelete(Byval this As IEvents Ptr, Byval iRow As Long) As Long
  Function=%S_OK
End Function


Function CreateSink2() As Dword
  Local pIEvents_Vtbl As IEventsVtbl Ptr
  Local pSink2 As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "  Entering CreateSink2()"
  #EndIf
  pIEvents_Vtbl=CoTaskMemAlloc(SizeOf(IEventsVtbl))
  If pIEvents_Vtbl Then
     @pIEvents_Vtbl.QueryInterface       = CodePtr(IEvents2_QueryInterface)
     @pIEvents_Vtbl.AddRef               = CodePtr(IEvents2_AddRef)
     @pIEvents_Vtbl.Release              = CodePtr(IEvents2_Release)
     @pIEvents_Vtbl.Grid_OnKeyPress      = CodePtr(IEvents2_OnKeyPress)
     @pIEvents_Vtbl.Grid_OnKeyDown       = CodePtr(IEvents2_OnKeyDown)
     @pIEvents_Vtbl.Grid_OnLButtonDown   = CodePtr(IEvents2_OnLButtonDown)
     @pIEvents_Vtbl.Grid_OnLButtonDblClk = CodePtr(IEvents2_OnLButtonDblClk)
     @pIEvents_Vtbl.Grid_OnPaste         = CodePtr(IEvents2_OnPaste)
     @pIEvents_Vtbl.Grid_OnRowSelection  = CodePtr(IEvents2_OnRowSelection)
     @pIEvents_Vtbl.Grid_OnDelete        = CodePtr(IEvents2_OnDelete)
     pSink2=CoTaskMemAlloc(SizeOf(CSink))
     If pSink2 Then
        @pSink2.lpIEventsVtbl = pIEvents_Vtbl
        #If %Def(%DEBUG)
        Prnt "    @pSink2.lpIEventsVtbl         = " & Str$(@pSink2.lpIEventsVtbl)
        #EndIf
        @pSink2.m_cRef=0
        #If %Def(%DEBUG)
        Prnt "    pSink2                        = " & Str$(pSink2)
        #EndIf
        @pSink2.hMain                           =     FindWindow($AppName, $AppName)
        #If %Def(%DEBUG)
        Prnt "    @pSink2.hMain                 = " & Str$(@pSink2.hMain)
        #EndIf
        CreateSink2=pSink2
     Else
        CreateSink2=0
     End If
  Else
     CreateSink2=0
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving CreateSink2()"
  #EndIf
End Function



Function IEvents3_QueryInterface(Byval this As IEvents Ptr, Byref iid As Guid, Byval ppv As Dword Ptr ) As Long
  #If %Def(%DEBUG)
  Prnt "  Entering IEvents3::QueryInterface() -- this = " & Str$(this)
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      #If %Def(%DEBUG)
      Prnt "  Trying To Get IUnknown"
      #EndIf
      Call IEvents3_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents3_QueryInterface()"
      #EndIf
    Case $IID_IGridEvents
      #If %Def(%DEBUG)
      Prnt "  Trying To Get $IID_IGridEvents"
      #EndIf
      Call IEvents3_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents3_QueryInterface()"
      #EndIf
    Case Else
      Function=%E_NOINTERFACE : Exit Function
  End Select

  Function=%S_Ok
End Function


Function IEvents3_AddRef(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "      Entering IEvents3_AddRef()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Incr @pSink.m_cRef
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
  Prnt "      Leaving IEvents3_AddRef()"
  #EndIf

  IEvents3_AddRef=@pSink.m_cRef
End Function


Function IEvents3_Release(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "    Entering IGridEvents3_Release()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Decr @pSink.m_cRef
  If @pSink.m_cRef=0 Then
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = 0 And Will Now Delete CGridSink3!"
     #EndIf
     Call CoTaskMemFree(@pSink.@lpIEventsVtbl)
     Call CoTaskMemFree(@this)
     #If %Def(%DEBUG)
     Prnt "      CGridSink2 Was Deleted!"
     Prnt "    Leaving IGridEvents2_Release()"
     #EndIf
     Function=0 : Exit Function
  Else
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
     Prnt "    Leaving IGridEvents3_Release()"
     #EndIf
     Function=@pSink.m_cRef : Exit Function
  End If
End Function


Function IEvents3_OnKeyPress(Byval this As IEvents Ptr, Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got KeyPress From Grid3!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
  #EndIf
  Function=%S_Ok
End Function


Function IEvents3_OnKeyDown(Byval this As IEvents Ptr,Byval iKeyCode As Long,Byval iKeyData As Long,Byval iCellRow As Long,Byval iGridRow As Long,Byval iCol As Long,Byref blnCancel As Long) As Long
  Function=%S_Ok
End Function


Function IEvents3_OnLButtonDown(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got WM_LBUTTONDOWN In Grid2 Cell " & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
  #EndIf
  Function=%S_Ok
End Function


Function IEvents3_OnLButtonDblClk(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents3_OnPaste(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents3_OnRowSelection(Byval this As IEvents Ptr, Byval iRow As Long, Byval iAction As Long) As Long
  Function=%S_Ok
End Function


Function IEvents3_OnDelete(Byval this As IEvents Ptr, Byval iRow As Long) As Long
  Function=%S_OK
End Function


Function CreateSink3() As Dword
  Local pIEvents_Vtbl As IEventsVtbl Ptr
  Local pSink3 As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "  Entering CreateSink3()"
  #EndIf
  pIEvents_Vtbl=CoTaskMemAlloc(SizeOf(IEventsVtbl))
  If pIEvents_Vtbl Then
     @pIEvents_Vtbl.QueryInterface       = CodePtr(IEvents3_QueryInterface)
     @pIEvents_Vtbl.AddRef               = CodePtr(IEvents3_AddRef)
     @pIEvents_Vtbl.Release              = CodePtr(IEvents3_Release)
     @pIEvents_Vtbl.Grid_OnKeyPress      = CodePtr(IEvents3_OnKeyPress)
     @pIEvents_Vtbl.Grid_OnKeyDown       = CodePtr(IEvents3_OnKeyDown)
     @pIEvents_Vtbl.Grid_OnLButtonDown   = CodePtr(IEvents3_OnLButtonDown)
     @pIEvents_Vtbl.Grid_OnLButtonDblClk = CodePtr(IEvents3_OnLButtonDblClk)
     @pIEvents_Vtbl.Grid_OnPaste         = CodePtr(IEvents3_OnPaste)
     @pIEvents_Vtbl.Grid_OnRowSelection  = CodePtr(IEvents3_OnRowSelection)
     @pIEvents_Vtbl.Grid_OnDelete        = CodePtr(IEvents3_OnDelete)
     pSink3=CoTaskMemAlloc(SizeOf(CSink))
     If pSink3 Then
        @pSink3.lpIEventsVtbl = pIEvents_Vtbl
        #If %Def(%DEBUG)
        Prnt "    @pSink3.lpIEventsVtbl         = " & Str$(@pSink3.lpIEventsVtbl)
        #EndIf
        @pSink3.m_cRef=0
        #If %Def(%DEBUG)
        Prnt "    pSink3                        = " & Str$(pSink3)
        #EndIf
        @pSink3.hMain                           =     FindWindow($AppName, $AppName)
        #If %Def(%DEBUG)
        Prnt "    @pSink3.hMain                 = " & Str$(@pSink3.hMain)
        #EndIf
        CreateSink3=pSink3
     Else
        CreateSink3=0
     End If
  Else
     CreateSink3=0
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving CreateSink3()"
  #EndIf
End Function


Function IEvents4_QueryInterface(Byval this As IEvents Ptr, Byref iid As Guid, Byval ppv As Dword Ptr ) As Long
  #If %Def(%DEBUG)
  Prnt "  Entering IEvents4::QueryInterface() -- this = " & Str$(this)
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      #If %Def(%DEBUG)
      Prnt "  Trying To Get IUnknown"
      #EndIf
      Call IEvents4_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents4_QueryInterface()"
      #EndIf
    Case $IID_IGridEvents
      #If %Def(%DEBUG)
      Prnt "  Trying To Get $IID_IGridEvents"
      #EndIf
      Call IEvents4_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IEvents4_QueryInterface()"
      #EndIf
    Case Else
      Function=%E_NOINTERFACE : Exit Function
  End Select

  Function=%S_Ok
End Function


Function IEvents4_AddRef(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "      Entering IEvents4_AddRef()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Incr @pSink.m_cRef
  #If %Def(%DEBUG)
  Prnt "        @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
  Prnt "      Leaving IEvents4_AddRef()"
  #EndIf

  IEvents4_AddRef=@pSink.m_cRef
End Function


Function IEvents4_Release(Byval this As IEvents Ptr) As Long
  Local pSink As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "    Entering IGridEvents4_Release()"
  #EndIf
  pSink=this
  #If %Def(%DEBUG)
  Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << Before"
  #EndIf
  Decr @pSink.m_cRef
  If @pSink.m_cRef=0 Then
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = 0 And Will Now Delete CGridSink4!"
     #EndIf
     Call CoTaskMemFree(@pSink.@lpIEventsVtbl)
     Call CoTaskMemFree(@this)
     #If %Def(%DEBUG)
     Prnt "      CGridSink4 Was Deleted!"
     Prnt "    Leaving IGridEvents4_Release()"
     #EndIf
     Function=0 : Exit Function
  Else
     #If %Def(%DEBUG)
     Prnt "      @pSink.m_cRef = " & Str$(@pSink.m_cRef) & "  << After"
     Prnt "    Leaving IGridEvents4_Release()"
     #EndIf
     Function=@pSink.m_cRef : Exit Function
  End If
End Function


Function IEvents4_OnKeyPress(Byval this As IEvents Ptr, Byval iKeyCode As Long, Byval iKeyData As Long, Byval iRow As Long, Byval iCol As Long, Byref blnCancel As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got KeyPress From Grid4!" & Str$(iKeyCode) & "=" & Chr$(iKeyCode)
  #EndIf
  Function=%S_Ok
End Function


Function IEvents4_OnKeyDown(Byval this As IEvents Ptr,Byval iKeyCode As Long,Byval iKeyData As Long,Byval iCellRow As Long,Byval iGridRow As Long,Byval iCol As Long,Byref blnCancel As Long) As Long
  Function=%S_Ok
End Function


Function IEvents4_OnLButtonDown(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  #If %Def(%DEBUG)
  Prnt "Got WM_LBUTTONDOWN In Grid4 Cell " & "(" & Trim$(Str$(iGridRow)) & "," & Trim$(Str$(iCol)) & ")"
  #EndIf
  Function=%S_Ok
End Function


Function IEvents4_OnLButtonDblClk(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents4_OnPaste(Byval this As IEvents Ptr, Byval iCellRow As Long, Byval iGridRow As Long, Byval iCol As Long) As Long
  Function=%S_Ok
End Function


Function IEvents4_OnRowSelection(Byval this As IEvents Ptr, Byval iRow As Long, Byval iAction As Long) As Long
  Function=%S_Ok
End Function


Function IEvents4_OnDelete(Byval this As IEvents Ptr, Byval iRow As Long) As Long
  Function=%S_OK
End Function


Function CreateSink4() As Dword
  Local pIEvents_Vtbl As IEventsVtbl Ptr
  Local pSink4 As CSink Ptr

  #If %Def(%DEBUG)
  Prnt "  Entering CreateSink4()"
  #EndIf
  pIEvents_Vtbl=CoTaskMemAlloc(SizeOf(IEventsVtbl))
  If pIEvents_Vtbl Then
     @pIEvents_Vtbl.QueryInterface       = CodePtr(IEvents4_QueryInterface)
     @pIEvents_Vtbl.AddRef               = CodePtr(IEvents4_AddRef)
     @pIEvents_Vtbl.Release              = CodePtr(IEvents4_Release)
     @pIEvents_Vtbl.Grid_OnKeyPress      = CodePtr(IEvents4_OnKeyPress)
     @pIEvents_Vtbl.Grid_OnKeyDown       = CodePtr(IEvents4_OnKeyDown)
     @pIEvents_Vtbl.Grid_OnLButtonDown   = CodePtr(IEvents4_OnLButtonDown)
     @pIEvents_Vtbl.Grid_OnLButtonDblClk = CodePtr(IEvents4_OnLButtonDblClk)
     @pIEvents_Vtbl.Grid_OnPaste         = CodePtr(IEvents4_OnPaste)
     @pIEvents_Vtbl.Grid_OnRowSelection  = CodePtr(IEvents4_OnRowSelection)
     @pIEvents_Vtbl.Grid_OnDelete        = CodePtr(IEvents4_OnDelete)
     pSink4=CoTaskMemAlloc(SizeOf(CSink))
     If pSink4 Then
        @pSink4.lpIEventsVtbl = pIEvents_Vtbl
        #If %Def(%DEBUG)
        Prnt "    @pSink4.lpIEventsVtbl         = " & Str$(@pSink4.lpIEventsVtbl)
        #EndIf
        @pSink4.m_cRef=0
        #If %Def(%DEBUG)
        Prnt "    pSink4                        = " & Str$(pSink4)
        #EndIf
        @pSink4.hMain                           =     FindWindow($AppName, $AppName)
        #If %Def(%DEBUG)
        Prnt "    @pSink4.hMain                 = " & Str$(@pSink4.hMain)
        #EndIf
        CreateSink4=pSink4
     Else
        CreateSink4=0
     End If
  Else
     CreateSink4=0
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving CreateSink4()"
  #EndIf
End Function

Interface IGrid $IID_IFHGrid : Inherit IAutomation
  Method CreateGrid _
  ( _
    Byval hParent             As Long, _
    Byval strSetup            As BStr, _
    Byval x                   As Long, _
    Byval y                   As Long, _
    Byval cx                  As Long, _
    Byval cy                  As Long, _
    Byval iRows               As Long, _
    Byval iCols               As Long, _
    Byval iRowHt              As Long, _
    Byval iSelectionBackColor As Long, _
    Byval iSelectionTextColor As Long, _
    Byval strFontName         As BStr, _
    Byval iFontSize           As Long, _
    Byval iFontWeight         As Long _
  )
  Method SetRowCount(Byval iRowCount As Long, Byval blnForce As Long)
  Method GetRowCount() As Long
  Method SetData(Byval iRow As Long, Byval iCol As Long, Byval strData As WString)
  Method GetData(Byval iRow As Long, Byval iCol As Long) As WString
  Method FlushData()
  Method Refresh()
  Method GetVisibleRows() As Long
  Method GethGrid() As Long
  Method GethCell(Byval iRow As Long, Byval iCol As Long) As Long
  Method GethComboBox(Byval iCol As Long) As Long
  Method SetCellAttributes(Byval iRow As Long, Byval iCol As Long, Byval iBackColor As Long, Byval iTextColor As Long) As Long
  Method DeleteRow(Byval iRow As Long)
End Interface


Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long
  Local pConnectionPointContainer1,pConnectionPointContainer2,pConnectionPointContainer3,pConnectionPointContainer4 As IConnectionPointContainer
  Local pConnectionPoint1,pConnectionPoint2,pConnectionPoint3,pConnectionPoint4 As IConnectionPoint
  Local dwCookie1,dwCookie2,dwCookie3,dwCookie4 As Dword
  Local pSink1,pSink2,pSink3,pSink4 As CSink Ptr
  Local pGridInterfaces As GridInterfaces Ptr
  Local pGrid1,pGrid2,pGrid3,pGrid4 As IGrid
  Local pCreateStruct As CREATESTRUCT Ptr
  Local strSetup,strCoordinate As BStr
  Local EventGuid As Guid
  Local szName As ZStr*16
  Local hCtl As Dword
  Register i As Long
  Register j As Long

  #If %Def(%DEBUG)
  Call AllocConsole()
  Prnt "Entering fnWndProc_OnCreate() In Host"
  #EndIf
  pCreateStruct=wea.lParam  :  wea.hInst=@pCreateStruct.hInstance
  pGridInterfaces=GlobalAlloc(%GPTR,sizeof(GridInterfaces))
  If pGridInterfaces=0 Then
     MsgBox("Memory Allocation Failure")
     Function=-1 : Exit Function
  End If
  Call SetWindowLong(Wea.hWnd,0,pGridInterfaces)
  #If %Def(%DEBUG)
  Prnt "  pGridInterfaces  = " & Str$(pGridInterfaces)
  #EndIf
  EventGuid=$IID_IGridEvents

  'Grid #1
  pGrid1 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Objptr(pGrid1) = " & Str$(Objptr(pGrid1))
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid1 = " & Str$(ObjPtr(pGrid1))
  #EndIf
  pGrid1.AddRef()
  @pGridInterfaces.pGrid1=Objptr(pGrid1)
  strSetup="60:Tree #:^:edit,60:Sp:^:edit,60:Dbh:^:edit,60:Ht:^:edit,60:Cull:^:edit,60:Gd:^:edit,60:Vol:^:edit,60:Block:^:edit,60:BkCtr:^:edit,60:RealSp:^:edit,60:Suffix:^:edit,60:Cru:^:edit"
  pGrid1.CreateGrid(Wea.hWnd,strSetup,10,10,570,141,%NUMBER_ROWS,%NUMBER_COLUMNS,20,0,0,"Courier New",10,%FW_BOLD)
  pSink1=CreateSink1()
  If pSink1 Then
     #If %Def(%DEBUG)
     Prnt "  pSink1         = " & Str$(pSink1)
     #EndIf
     pConnectionPointContainer1 = pGrid1
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPointContainer1) = " & Str$(Objptr(pConnectionPointContainer1))
     #EndIf
     Call pConnectionPointContainer1.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint1))
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPoint1) = " & Str$(Objptr(pConnectionPoint1))
     #EndIf
     Call pConnectionPoint1.Advise(Byval pSink1, dwCookie1)
     #If %Def(%DEBUG)
     Prnt "  dwCookie1      = " & Str$(dwCookie1)
     #EndIf
     @pGridInterfaces.dwCookie1=dwCookie1
     hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,158,150,24,Wea.hWnd,%IDC_RETRIEVE1,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Color Some Rows",%WS_CHILD Or %WS_VISIBLE,220,158,150,24,Wea.hWnd,%IDC_COLOR1,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,158,150,24,Wea.hWnd,%IDC_UNLOAD_GRID1,Wea.hInst,ByVal 0)
     For i=1 To %NUMBER_ROWS
       For j=1 To %NUMBER_COLUMNS
         strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
         pGrid1.SetData(i,j,strCoordinate)
       Next j
    Next i
    pGrid1.Refresh()
  End If

  'Grid #2
  pGrid2 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Objptr(pGrid1) = " & Str$(Objptr(pGrid2))
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid2 = " & Str$(ObjPtr(pGrid2))
  #EndIf
  pGrid2.AddRef()
  @pGridInterfaces.pGrid2=Objptr(pGrid2)
  strSetup="60:Tree #:^:edit,60:Sp:^:edit,60:Dbh:^:edit,60:Ht:^:edit,60:Cull:^:edit,60:Gd:^:edit,60:Vol:^:edit,60:Block:^:edit,60:BkCtr:^:edit,60:RealSp:^:edit,60:Suffix:^:edit,60:Cru:^:edit"
  pGrid2.CreateGrid(Wea.hWnd,strSetup,10,197,570,141,%NUMBER_ROWS,%NUMBER_COLUMNS,20,0,0,"Arial",10,%FW_BOLD)
  pSink2=CreateSink2()
  If pSink2 Then
     #If %Def(%DEBUG)
     Prnt "  pSink2         = " & Str$(pSink2)
     #EndIf
     pConnectionPointContainer2 = pGrid2
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPointContainer2) = " & Str$(Objptr(pConnectionPointContainer2))
     #EndIf
     Call pConnectionPointContainer2.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint2))
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPoint2) = " & Str$(Objptr(pConnectionPoint2))
     #EndIf
     Call pConnectionPoint2.Advise(Byval pSink2, dwCookie2)
     #If %Def(%DEBUG)
     Prnt "  dwCookie2      = " & Str$(dwCookie2)
     #EndIf
     @pGridInterfaces.dwCookie2=dwCookie2
     hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,346,150,24,Wea.hWnd,%IDC_RETRIEVE2,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Color Some Rows",%WS_CHILD Or %WS_VISIBLE,220,346,150,24,Wea.hWnd,%IDC_COLOR2,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,346,150,24,Wea.hWnd,%IDC_UNLOAD_GRID2,Wea.hInst,ByVal 0)
     For i=1 To %NUMBER_ROWS
       For j=1 To %NUMBER_COLUMNS
         strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
         pGrid2.SetData(i,j,strCoordinate)
       Next j
    Next i
    pGrid2.Refresh()
  End If

  'Grid #3
  pGrid3 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Objptr(pGrid3) = " & Str$(Objptr(pGrid3))
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid3 = " & Str$(ObjPtr(pGrid3))
  #EndIf
  pGrid3.AddRef()
  @pGridInterfaces.pGrid3=Objptr(pGrid3)
  strSetup="60:Tree #:^:edit,60:Sp:^:edit,60:Dbh:^:edit,60:Ht:^:edit,60:Cull:^:edit,60:Gd:^:edit,60:Vol:^:edit,60:Block:^:edit,60:BkCtr:^:edit,60:RealSp:^:edit,60:Suffix:^:edit,60:Cru:^:edit"
  pGrid3.CreateGrid(Wea.hWnd,strSetup,10,387,570,141,%NUMBER_ROWS,%NUMBER_COLUMNS,20,0,0,"Tahoma",10,%FW_BOLD)
  pSink3=CreateSink3()
  If pSink3 Then
     #If %Def(%DEBUG)
     Prnt "  pSink3         = " & Str$(pSink3)
     #EndIf
     pConnectionPointContainer3 = pGrid3
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPointContainer3) = " & Str$(Objptr(pConnectionPointContainer3))
     #EndIf
     Call pConnectionPointContainer3.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint3))
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPoint3) = " & Str$(Objptr(pConnectionPoint3))
     #EndIf
     Call pConnectionPoint3.Advise(Byval pSink3, dwCookie3)
     #If %Def(%DEBUG)
     Prnt "  dwCookie3      = " & Str$(dwCookie3)
     #EndIf
     @pGridInterfaces.dwCookie3=dwCookie3
     hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,534,150,24,Wea.hWnd,%IDC_RETRIEVE3,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Color Some Rows",%WS_CHILD Or %WS_VISIBLE,220,534,150,24,Wea.hWnd,%IDC_COLOR3,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,534,150,24,Wea.hWnd,%IDC_UNLOAD_GRID3,Wea.hInst,ByVal 0)
     For i=1 To %NUMBER_ROWS
       For j=1 To %NUMBER_COLUMNS
         strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
         pGrid3.SetData(i,j,strCoordinate)
       Next j
    Next i
    pGrid3.Refresh()
  End If

  'Grid #4
  pGrid4 = NewCom "FHGrid9.Grid"
  #If %Def(%DEBUG)
  Prnt "  Objptr(pGrid4) = " & Str$(Objptr(pGrid4))
  Prnt "  Successfully Created FHGrid9.Grid! : " & " pGrid4 = " & Str$(ObjPtr(pGrid4))
  #EndIf
  pGrid4.AddRef()
  @pGridInterfaces.pGrid4=Objptr(pGrid4)
  strSetup="60:Tree #:^:edit,60:Sp:^:edit,60:Dbh:^:edit,60:Ht:^:edit,60:Cull:^:edit,60:Gd:^:edit,60:Vol:^:edit,60:Block:^:edit,60:BkCtr:^:edit,60:RealSp:^:edit,60:Suffix:^:edit,60:Cru:^:edit"
  pGrid4.CreateGrid(Wea.hWnd,strSetup,10,577,570,141,%NUMBER_ROWS,%NUMBER_COLUMNS,20,0,0,"Times New Roman",10,%FW_BOLD)
  pSink4=CreateSink4()
  If pSink4 Then
     #If %Def(%DEBUG)
     Prnt "  pSink4         = " & Str$(pSink4)
     #EndIf
     pConnectionPointContainer4 = pGrid4
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPointContainer4) = " & Str$(Objptr(pConnectionPointContainer4))
     #EndIf
     Call pConnectionPointContainer4.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint4))
     #If %Def(%DEBUG)
     Prnt "  Objptr(pConnectionPoint4) = " & Str$(Objptr(pConnectionPoint4))
     #EndIf
     Call pConnectionPoint4.Advise(Byval pSink4, dwCookie4)
     #If %Def(%DEBUG)
     Prnt "  dwCookie4      = " & Str$(dwCookie4)
     #EndIf
     @pGridInterfaces.dwCookie4=dwCookie4
     hCtl=CreateWindow("button","Retrieve Cell (3,2)",%WS_CHILD Or %WS_VISIBLE,30,724,150,24,Wea.hWnd,%IDC_RETRIEVE4,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Color Some Rows",%WS_CHILD Or %WS_VISIBLE,220,724,150,24,Wea.hWnd,%IDC_COLOR4,Wea.hInst,ByVal 0)
     hCtl=CreateWindow("button","Unload Grid",%WS_CHILD Or %WS_VISIBLE,400,724,150,24,Wea.hWnd,%IDC_UNLOAD_GRID4,Wea.hInst,ByVal 0)
     For i=1 To %NUMBER_ROWS
       For j=1 To %NUMBER_COLUMNS
         strCoordinate="(" & Trim$(Str$(i)) & "," & Trim$(Str$(j)) & ")"
         pGrid4.SetData(i,j,strCoordinate)
       Next j
    Next i
    pGrid4.Refresh()
  End If
  #If %Def(%DEBUG)
  Prnt "Leaving fnWndProc_OnCreate() In Host"
  #EndIf

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnCommand(Wea As WndEventArgs) As Long
  Local pConnectionPointContainer As IConnectionPointContainer
  Local pGridInterfaces As GridInterfaces Ptr
  Local pConnectionPoint As IConnectionPoint
  Local dwCookie As Dword
  Local EventGuid As Guid
  Local strData As BStr
  Local pGrid As IGrid
  Register i As Long
  Local hr As Long

  #If %Def(%DEBUG)
  Prnt "Entering fnWndProc_OnCommand()"
  #EndIf
  pGridInterfaces=GetWindowLong(Wea.hWnd,0)
  #If %Def(%DEBUG)
  Prnt "  pGridInterfaces         = " & Str$(pGridInterfaces)
  #EndIf
  EventGuid=$IID_IGridEvents
  Select Case As Long Lowrd(Wea.wParam)
    Case %IDC_RETRIEVE1
      If @pGridInterfaces.pGrid1 Then
         CObj(pGrid,@pGridInterfaces.pGrid1)
         pGrid.AddRef()
         pGrid.FlushData()
         strData=pGrid.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell (3,2) Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_RETRIEVE2
      If @pGridInterfaces.pGrid2 Then
         CObj(pGrid,@pGridInterfaces.pGrid2)
         pGrid.AddRef()
         pGrid.FlushData()
         strData=pGrid.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell (3,2) Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_RETRIEVE3
       If @pGridInterfaces.pGrid3 Then
         CObj(pGrid,@pGridInterfaces.pGrid3)
         pGrid.AddRef()
         pGrid.FlushData()
         strData=pGrid.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell (3,2) Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_RETRIEVE4
      If @pGridInterfaces.pGrid4 Then
         CObj(pGrid,@pGridInterfaces.pGrid4)
         pGrid.AddRef()
         pGrid.FlushData()
         strData=pGrid.GetData(3,2)
         #If %Def(%DEBUG)
         Prnt "Cell 3,2 Contains " & strData
         #Else
         MsgBox("Cell (3,2) Contains The Text " & strData & ".")
         #EndIf
      End If
    Case %IDC_COLOR1
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR1
         #EndIf
         If @pGridInterfaces.pGrid1 Then
            CObj(pGrid,@pGridInterfaces.pGrid1)
            pGrid.AddRef()
            pGrid.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_COLOR2
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR2
         #EndIf
         If @pGridInterfaces.pGrid2 Then
            CObj(pGrid,@pGridInterfaces.pGrid2)
            pGrid.AddRef()
            pGrid.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_COLOR3
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR3
         #EndIf
         If @pGridInterfaces.pGrid3 Then
            CObj(pGrid,@pGridInterfaces.pGrid3)
            pGrid.AddRef()
            pGrid.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_COLOR4
      #If %Def(%DEBUG)
      Prnt "Entering fnWndProc_OnCommand()"
      #EndIf
      If Hiwrd(Wea.wParam)=%BN_CLICKED Then
         #If %Def(%DEBUG)
         Prnt "  Case %IDC_COLOR4
         #EndIf
         If @pGridInterfaces.pGrid4 Then
            CObj(pGrid,@pGridInterfaces.pGrid4)
            pGrid.AddRef()
            pGrid.FlushData()
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(3,i,&H000000FF,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(4,i,&H0000FF00,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(5,i,&H00FF0000,&H00FFFFFF)
            Next i
            For i=1 To %NUMBER_COLUMNS
              pGrid.SetCellAttributes(6,i,RGB(255,255,0),&H00000001)
            Next i
            pGrid.Refresh()
         End If
      End If
      #If %Def(%DEBUG)
      Prnt "Leaving fnWndProc_OnCommand()"
      #EndIf
    Case %IDC_UNLOAD_GRID1
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid1 = " & Str$(@pGridInterfaces.pGrid1)
      #EndIf
      If @pGridInterfaces.pGrid1 Then
         CObj(pGrid,@pGridInterfaces.pGrid1)
         dwCookie=@pGridInterfaces.dwCookie1
         @pGridInterfaces.pGrid1=0
         pConnectionPointContainer=pGrid
         If IsObject(pConnectionPointContainer) Then
            hr=pConnectionPointContainer.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint))
            If SUCCEEDED(hr) Then
               hr=pConnectionPoint.Unadvise(dwCookie)
               If SUCCEEDED(hr) Then
                  #If %Def(%DEBUG)
                  Prnt "  pConnectionPoint.Unadvise(dwCookie)   Succeeded!"
                  #EndIf
                  Set pGrid=Nothing
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE1),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR1),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID1),%False)
                  Call InvalidateRect(Wea.hWnd, Byval 0, %True)
               End If
            End If
         End If
      End If
    Case %IDC_UNLOAD_GRID2
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid2 = " & Str$(@pGridInterfaces.pGrid2)
      #EndIf
      If @pGridInterfaces.pGrid2 Then
         CObj(pGrid,@pGridInterfaces.pGrid2)
         dwCookie=@pGridInterfaces.dwCookie2
         @pGridInterfaces.pGrid2=0
         pConnectionPointContainer=pGrid
         If IsObject(pConnectionPointContainer) Then
            hr=pConnectionPointContainer.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint))
            If SUCCEEDED(hr) Then
               hr=pConnectionPoint.Unadvise(dwCookie)
               If SUCCEEDED(hr) Then
                  #If %Def(%DEBUG)
                  Prnt "  pConnectionPoint.Unadvise(dwCookie)   Succeeded!"
                  #EndIf
                  Set pGrid=Nothing
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE2),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR2),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID2),%False)
                  Call InvalidateRect(Wea.hWnd, Byval 0, %True)
               End If
            End If
         End If
      End If
    Case %IDC_UNLOAD_GRID3
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid3 = " & Str$(@pGridInterfaces.pGrid3)
      #EndIf
      If @pGridInterfaces.pGrid3 Then
         CObj(pGrid,@pGridInterfaces.pGrid3)
         dwCookie=@pGridInterfaces.dwCookie3
         @pGridInterfaces.pGrid3=0
         pConnectionPointContainer=pGrid
         If IsObject(pConnectionPointContainer) Then
            hr=pConnectionPointContainer.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint))
            If SUCCEEDED(hr) Then
               hr=pConnectionPoint.Unadvise(dwCookie)
               If SUCCEEDED(hr) Then
                  #If %Def(%DEBUG)
                  Prnt "  pConnectionPoint.Unadvise(dwCookie)   Succeeded!"
                  #EndIf
                  Set pGrid=Nothing
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE3),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR3),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID3),%False)
                  Call InvalidateRect(Wea.hWnd, Byval 0, %True)
               End If
            End If
         End If
      End If
    Case %IDC_UNLOAD_GRID4
      #If %Def(%DEBUG)
      Prnt "  @pGridInterfaces.pGrid4 = " & Str$(@pGridInterfaces.pGrid4)
      #EndIf
      If @pGridInterfaces.pGrid4 Then
         CObj(pGrid,@pGridInterfaces.pGrid4)
         dwCookie=@pGridInterfaces.dwCookie4
         @pGridInterfaces.pGrid4=0
         pConnectionPointContainer=pGrid
         If IsObject(pConnectionPointContainer) Then
            hr=pConnectionPointContainer.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint))
            If SUCCEEDED(hr) Then
               hr=pConnectionPoint.Unadvise(dwCookie)
               If SUCCEEDED(hr) Then
                  #If %Def(%DEBUG)
                  Prnt "  pConnectionPoint.Unadvise(dwCookie)   Succeeded!"
                  #EndIf
                  Set pGrid=Nothing
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_RETRIEVE4),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_COLOR4),%False)
                  Call EnableWindow(GetDlgItem(Wea.hWnd,%IDC_UNLOAD_GRID4),%False)
                  Call InvalidateRect(Wea.hWnd, Byval 0, %True)
               End If
            End If
         End If
      End If
  End Select
  #If %Def(%DEBUG)
  Prnt "Leaving fnWndProc_OnCommand()"
  #EndIf

  fnWndProc_OnCommand=0
End Function


Function fnWndProc_OnDestroy(Wea As WndEventArgs) As Long
  Local pConnectionPointContainer1,pConnectionPointContainer2,pConnectionPointContainer3,pConnectionPointContainer4 As IConnectionPointContainer
  Local pConnectionPoint1,pConnectionPoint2,pConnectionPoint3,pConnectionPoint4 As IConnectionPoint
  Local dwCookie1,dwCookie2,dwCookie3,dwCookie4 As Dword
  Local pGridInterfaces As GridInterfaces Ptr
  Local pGrid1,pGrid2,pGrid3,pGrid4 As IGrid
  Local blnFree,hr As Long
  Local EventGuid As Guid

  #If %Def(%DEBUG)
  Prnt "Entering fnWndProc_OnDestroy() In Host"
  #EndIf
  pGridInterfaces=GetWindowLong(Wea.hWnd,0)
  #If %Def(%DEBUG)
  Prnt "  pGridInterfaces = " & Str$(pGridInterfaces)
  #EndIf
  EventGuid=$IID_IGridEvents
  If @pGridInterfaces.pGrid1 Then
     CObj(pGrid1,@pGridInterfaces.pGrid1)
     dwCookie1=@pGridInterfaces.dwCookie1
     @pGridInterfaces.pGrid1=0
     pConnectionPointContainer1=pGrid1
     If IsObject(pConnectionPointContainer1) Then
        hr=pConnectionPointContainer1.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint1))
        If SUCCEEDED(hr) Then
           hr=pConnectionPoint1.Unadvise(dwCookie1)
           If SUCCEEDED(hr) Then
              #If %Def(%DEBUG)
              Prnt "  pConnectionPoint1.Unadvise(dwCookie1)   Succeeded!"
              #EndIf
              Set pGrid1=Nothing
              Set pConnectionPoint1=Nothing
              Set pConnectionPointContainer1=Nothing
           End If
        End If
     End If
  End If
  If @pGridInterfaces.pGrid2 Then
     CObj(pGrid2,@pGridInterfaces.pGrid2)
     dwCookie2=@pGridInterfaces.dwCookie2
     @pGridInterfaces.pGrid2=0
     pConnectionPointContainer2=pGrid2
     If IsObject(pConnectionPointContainer2) Then
        hr=pConnectionPointContainer2.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint2))
        If SUCCEEDED(hr) Then
           hr=pConnectionPoint2.Unadvise(dwCookie2)
           If SUCCEEDED(hr) Then
              #If %Def(%DEBUG)
              Prnt "  pConnectionPoint2.Unadvise(dwCookie2)   Succeeded!"
              #EndIf
              Set pGrid2=Nothing
              Set pConnectionPoint2=Nothing
              Set pConnectionPointContainer2=Nothing
           End If
        End If
     End If
  End If
  If @pGridInterfaces.pGrid3 Then
     CObj(pGrid3,@pGridInterfaces.pGrid3)
     dwCookie3=@pGridInterfaces.dwCookie3
     @pGridInterfaces.pGrid3=0
     pConnectionPointContainer3=pGrid3
     If IsObject(pConnectionPointContainer3) Then
        hr=pConnectionPointContainer3.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint3))
        If SUCCEEDED(hr) Then
           hr=pConnectionPoint3.Unadvise(dwCookie3)
           If SUCCEEDED(hr) Then
              #If %Def(%DEBUG)
              Prnt "  pConnectionPoint3.Unadvise(dwCookie3)   Succeeded!"
              #EndIf
              Set pGrid3=Nothing
              Set pConnectionPoint3=Nothing
              Set pConnectionPointContainer3=Nothing
           End If
        End If
     End If
  End If
  If @pGridInterfaces.pGrid4 Then
     CObj(pGrid4,@pGridInterfaces.pGrid4)
     dwCookie4=@pGridInterfaces.dwCookie4
     @pGridInterfaces.pGrid4=0
     pConnectionPointContainer4=pGrid4
     If IsObject(pConnectionPointContainer4) Then
        hr=pConnectionPointContainer4.FindConnectionPoint(Byval Varptr(EventGuid), Byval Varptr(pConnectionPoint4))
        If SUCCEEDED(hr) Then
           hr=pConnectionPoint4.Unadvise(dwCookie4)
           If SUCCEEDED(hr) Then
              #If %Def(%DEBUG)
              Prnt "  pConnectionPoint4.Unadvise(dwCookie4)   Succeeded!"
              #EndIf
              Set pGrid4=Nothing
              Set pConnectionPoint4=Nothing
              Set pConnectionPointContainer4=Nothing
           End If
        End If
     End If
  End If
  If pGridInterfaces Then
     blnFree=GlobalFree(pGridInterfaces)
     #If %Def(%DEBUG)
     Prnt "  GlobalFree(pGridInterfaces) = " & Str$(blnFree)
     #EndIf
  Else
     #If %Def(%DEBUG)
     Prnt "  GlobalFree(pGridInterfaces) Failed Or Was Already Released!"
     #EndIf
  End If
  Call CoFreeUnusedLibraries()
  Call PostQuitMessage(0)
  #If %Def(%DEBUG)
  Prnt "Leaving fnWndProc_OnDestroy() In Host"
  #EndIf

  fnWndProc_OnDestroy=0
End Function


Sub AttachMessageHandlers()
  Dim MsgHdlr(2) As Global MessageHandler 'Associate Windows Message With Message Handlers
  MsgHdlr(0).wMessage=%WM_CREATE          : MsgHdlr(0).dwFnPtr=CodePtr(fnWndProc_OnCreate)
  MsgHdlr(1).wMessage=%WM_COMMAND         : MsgHdlr(1).dwFnPtr=CodePtr(fnWndProc_OnCommand)
  MsgHdlr(2).wMessage=%WM_DESTROY         : MsgHdlr(2).dwFnPtr=CodePtr(fnWndProc_OnDestroy)
End Sub


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 2
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnWndProc=iReturn
       Exit Function
    End If
  Next i

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hInstance As Long, ByVal hPrevIns As Long, ByVal lpCmdLn As ZStr Ptr, ByVal iShow As Long) As Long
  Local szAppName As ZStr*16
  Local wc As WndClassEx
  Local hWnd As Dword
  Local Msg As tagMsg

  szAppName="Grid Test"                           : Call AttachMessageHandlers()
  wc.lpszClassName = VarPtr(szAppName)            : wc.lpfnWndProc   = CodePtr(fnWndProc)
  wc.cbWndExtra    = 4                            : wc.cbSize        = SizeOf(wc)
  wc.hInstance     = hInstance                    : wc.hbrBackground = %COLOR_BTNFACE+1
  Call RegisterClassEx(wc)
  hWnd=CreateWindowEx(0,szAppName,szAppName,%WS_OVERLAPPEDWINDOW,300,50,600,790,0,0,hInstance,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend : MsgBox("Last Chance To Get What You Can!")

  Function=msg.wParam
End Function
